"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var Lint = require("tslint");
var Rule = (function (_super) {
    tslib_1.__extends(Rule, _super);
    function Rule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Rule.prototype.apply = function (sourceFile) {
        var failures = [];
        var text = sourceFile.getText();
        var regExp = /\/\/\s+Expect(Type|Error)/g;
        var result;
        while ((result = regExp.exec(text))) {
            failures.push(new Lint.RuleFailure(sourceFile, result.index, result.index + result[0].length, Rule.FAILURE_STRING, this.ruleName));
        }
        return failures;
    };
    Rule.metadata = {
        description: "Disallows dtslint $ExpectType and $ExpectError expectations if the $ is missing.",
        options: null,
        optionsDescription: "Not configurable.",
        requiresTypeInfo: false,
        ruleName: "no-missing-dollar-expect",
        type: "functionality",
        typescriptOnly: false
    };
    Rule.FAILURE_STRING = "Missing $";
    return Rule;
}(Lint.Rules.AbstractRule));
exports.Rule = Rule;
